<?php

/**
 This project has been generated by worker generator
 has been made by fahmi sulaiman
 sulaimanfahmi@gmail.com
 check out my github @dekaulitz
 */

namespace App\Http\Services;
use App\Http\Models\ItempenerimaanbarangioModel;
use App\Http\Base\BaseService;
use Illuminate\Support\Facades\DB;
class ItempenerimaanbarangioService extends BaseService
{
    /**
     ItempenerimaanbarangioService constructor.
    */
    public function __construct()
    {
        parent::__construct();
        $this->model= new ItempenerimaanbarangioModel();
    }

	/**
	*  index function that get all data from database by default
	*  @return array|static[]
	*/
	public function index()
	{
		return $this->model->getQuery()->get();
	}


	/**
	*  this function is magic pagination injector from my library you want to add new property or field you have to inject into model in alias paging property
	*  @param array $input
	*  @return array
	*/
	public function paging($input)
	{
		$this->model->joinRelationItemId()->joinRelationPenerimaanBarangId()->getQuery()->select([
			"itempenerimaanbarangio.id as id",
			"itemId.id as itemId",
			"itemId.namaItem as namaItem",
			"itempenerimaanbarangio.rcNumber as rcNumber",
			"itempenerimaanbarangio.quantity as quantity"
		]);
		$this->model->paging()->filter()->sorting();
		return $this->model->paging()->getPaging();
	}

	/**
	*  get one raw row data from table by id
	*  you can ad the relation like $this->model->joinSomething()->getQuery()->where("aliastable.field","=",$value)->first()
	*  or like $this->model->joinSomething()->getQuery()->where("aliastable.field","=",$value)->select(["aliastable.fieldname"])->first(); its mean you want to join an take spesific value
	*  and you want to take value like this $model->fieldname
	*  @param $id
	*  @return ItempenerimaanbarangioModel
	*/
	public function show($id)
	{
		$model=$this->model->getQuery()->where("itempenerimaanbarangio.id","=",$id)->first();
		return $model;
	}


	/**
	*  this is a base function for storing data you with transaction by default
	*  you can customization base on your business requirement as you want, you can add other object or you can to loop anc excecute the process in single process
	*  @param array $input
	*  @return ItempenerimaanbarangioModel
	*  @throws \Exception
	*/
	public function store($input)
	{
		if(isset($input["itemID"]) && ! empty($input["itemID"])) {
			$newInput = $this->getPrepare($input);
			if(! empty($newInput)) {
				// $this->model->fill($newInput);
				foreach($newInput as $row) {
					$itemBrg = new ItempenerimaanbarangioModel();
					$itemBrg->fill($row);
					if(! $itemBrg->save()) {
						throw new \Exception();
					}
				}
				return $this->model;
			}
		}
	}

	private function getPrepare($input) {
		$data = [];
		if(isset($input["itemID"]) && ! empty($input["itemID"])) {
			foreach($input["itemID"] as $idx => $value) {
				$data[] = [	
							"rcNumber" 				=> $input["rcNumber"], 
							"itemId" 				=> $value, 
							"receiptDate" 			=> $input["tanggalPenerimaan"], 
							"quantity" 				=> $input["quantity"][$value], 
							"lotNumber" 			=> $input["lotNumber"][$value], 
							"lokasiId" 				=> $input["lokasiId"][$value]
				];
			}
		}
		return $data;
	}


	/**
	* this function will delete much data, in one action
	* the ids is a parameter from view like 1,2,3,4 and the parameter will be exploded into single array
	* you can remove this main alogorithm with your business requirement like soft delete or anything you want
	*  @param $ids
	*/
	public function delete($ids){
		$params = explode(".", $ids);
		$this->model->deleteBulk("id", $params);
	}


	/**
	*  this is a base function for update and delete data by default.
	*  you can add and custom as you want base on your requirement you can add this function as core function for handle update data from table or 
	*  you can add multiple relation proses after update in this function 
	*  @param $id
	*  @param array $input 
	*  @return ItempenerimaanbarangioModel
	*  @throws \Exception
	*/
	public function update($id,$input)
	{
		$itempenerimaanbarangio=ItempenerimaanbarangioModel::find($id);
		$itempenerimaanbarangio->fill($input);
		if(!$itempenerimaanbarangio->update()){
			throw new \Exception();
		}
		return $itempenerimaanbarangio;
	}


	/**
	*  this function will be confirting paging property into file excel
	*  the main library is base on excel spreadsheet library
	*  @param array $input
	*   @return array|static[]
	*/
	public function exportToExcel($input =array())
	{
		return $this->model->getQuery()->get();
	}


	public function showBasedOnPenerimaanbarangio($request, $headerTransaction) {
		$auth = json_decode($request->session()->get('auth'));
		
		$model = $this->model->joinRelationItemId("itemId")->joinRelationLokasiId()->getQuery()
		->where("itempenerimaanbarangio.rcNumber", "=", $headerTransaction->rcNumber)
		->where("itemId.kapalId", "=", $headerTransaction->kapalId)
		// ->where("lokasiId.kapalId", "=", $headerTransaction->kapalId)
		->whereIn("itemId.type_id", $auth->arrCategory)
		->where("itemId.enabled_flex", "=", "Y")
		->whereIn("itempenerimaanbarangio.lokasiId", $auth->arrLokasi)
		->select([	"itempenerimaanbarangio.id as id",
					"itemId.namaItem as namaItem",
					"itemId.part_number as partNumber",
					"itemId.deskripsi as deskripsi",
					"itemId.category as category",
					"itemId.UOM as UOM",
					"itempenerimaanbarangio.quantity as quantity",
					"itempenerimaanbarangio.lokasiId as lokasiId",
					"lokasiId.namaLokasi as namaLokasi",
					"itempenerimaanbarangio.lotNumber as lotNumber"])->get();
		return $model;
	}

	public function getStokSupply($kapalId, $arrIDs, $dateStart, $dateEnd) {
		$model = $this->model->joinRelationPenerimaanBarangIoId()->getQuery()
		->where("penerimaanBarangIoId.kapalId", "=", $kapalId)
		->whereIn("itempenerimaanbarangio.itemId", $arrIDs)
		->whereRaw('"penerimaanBarangIoId"."tanggalPenerimaan" BETWEEN  \'' . $dateStart . '\' AND \'' . $dateEnd . '\' ')
		->selectRaw(' SUM("itempenerimaanbarangio"."quantity") AS "nItem", "itempenerimaanbarangio"."itemId" ')
		->groupBy("itempenerimaanbarangio.itemId")
		->get();

		$arrItems = [];
		foreach($model as $row) {
			$arrItems[$row->itemId] = $row->nItem;
		}

		return $arrItems;
	}


}